;################################################################################
;#										#
;# mode 7 engine (4 channel PWM)						#
;# copyright (c) 2009-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;-------------------------------------------------------------------------------
; no input function available
;-------------------------------------------------------------------------------
inex:		ldi	ereg,40			;no IO driver
		ret

;-------------------------------------------------------------------------------
; output from 0x900 .. 0x9ff
;-------------------------------------------------------------------------------
outex:		cpi	YH,8
		brne	outex_100

outex_10:	cpi	YL,0x00
		brne	outex_12
		sbrc	XL,0
		sbi	PORTA,0
		sbrs	XL,0
		cbi	PORTA,0
		ret
outex_12:	cpi	YL,0x01
		brne	outex_14
		sbrc	XL,0
		sbi	PORTA,1
		sbrs	XL,0
		cbi	PORTA,1
		ret
outex_14:	cpi	YL,0x02
		brne	outex_16
		sbrc	XL,0
		sbi	PORTA,2
		sbrs	XL,0
		cbi	PORTA,2
		ret
outex_16:	cpi	YL,0x03
		brne	outex_50
		sbrc	XL,0
		sbi	PORTA,3
		sbrs	XL,0
		cbi	PORTA,3
		ret

outex_50:	cpi	YL,0x10
		brne	outex_52
		sbrc	XL,0
		sbi	DDRA,0
		sbrs	XL,0
		cbi	DDRA,0
		ret
outex_52:	cpi	YL,0x11
		brne	outex_54
		sbrc	XL,0
		sbi	DDRA,1
		sbrs	XL,0
		cbi	DDRA,1
		ret
outex_54:	cpi	YL,0x12
		brne	outex_56
		sbrc	XL,0
		sbi	DDRA,2
		sbrs	XL,0
		cbi	DDRA,2
		ret
outex_56:	cpi	YL,0x13
		brne	outex_err
		sbrc	XL,0
		sbi	DDRA,3
		sbrs	XL,0
		cbi	DDRA,3
		ret

outex_100:	cpi	YH,0x09
		brne	outex_err
		cpi	YL,8
		brcc	outex_err
		rjmp	pwm4x8_set

outex_err:	ldi	ereg,40			;no IO driver
		ret

